import { PluginPass, PluginObj, BabelFileMetadata, BabelFileResult } from '@babel/core';
import * as _babel_types from '@babel/types';
import { JSXElement, Expression } from '@babel/types';
import { NodePath } from '@babel/traverse';

type Macro = (this: Context, ...args: any[]) => Record<string, any> | void;
interface Options$1 {
    macros?: Record<string, Macro>[];
    define?: Record<string, Context>[];
    polyfill?: string | null;
    apply?(path: NodePath<JSXElement>, using: Iterable<Context>, state: BabelState): void;
}
type BabelState = PluginPass & {
    context: Context;
    opts: Options$1;
};

declare class Context {
    path: NodePath;
    parent: Context | undefined;
    define: Record<string, Context>;
    macros: Record<string, Macro>;
    uid: string;
    also: Set<Context>;
    props: Map<string, any>;
    usedBy: Set<NodePath<_babel_types.Node>>;
    children: Set<Context>;
    condition?: Expression | string;
    alternate?: Context;
    static get(from: NodePath): Context | undefined;
    constructor(path: NodePath, parent?: Context, name?: string);
}

type State = PluginPass & {
    context: Context;
    opts: Options$1;
};
declare namespace Plugin {
    export { Context, type Macro, type Options$1 as Options };
}
declare function Plugin(_compiler: any, options: Options$1): PluginObj<State>;

interface Options extends Plugin.Options {
    cssModule?: string;
}
declare namespace Preset {
    export type { Options };
    export interface Meta extends BabelFileMetadata {
        css: string;
    }
    export interface Result extends BabelFileResult {
        metadata: Meta;
        code: string;
    }
    export interface MetaData {
        readonly css: string;
        styles: Map<string, Context>;
    }
}
declare function Preset(_compiler: any, options?: Preset.Options): any;

export { Preset as default };
